package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.Function;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPBROS_WS_ERROR_MESSAGE {
    public @Getter @Builder.Default String unnamedVariable1 = "** OSC ERROR -- CONTACT HELP DESK ";
    public @Getter @Builder.Default String unnamedVariable2 = "-- REPORT THIS INFORMATION **     ";
    public @Getter @Builder.Default String unnamedVariable3 = StringUtils
            .repeat(' ', 9);
    public @Getter @Builder.Default String unnamedVariable4 = "   EIBTRNID = ";
    public @Getter @Builder.Default String WS_EIBTRNID = StringUtils.repeat(
            ' ', 4);
    public @Getter @Builder.Default String unnamedVariable5 = StringUtils
            .repeat(' ', 61);
    public @Getter @Builder.Default String unnamedVariable6 = "   EIBRSRCE = ";
    public @Getter @Builder.Default String WS_EIBRSRCE = StringUtils.repeat(
            ' ', 8);
    public @Getter @Builder.Default String unnamedVariable7 = StringUtils
            .repeat(' ', 57);
    public @Getter @Builder.Default String unnamedVariable8 = "   EIBRESP  = ";
    private final static Function<Integer, String> WS_EIBRESP_format = (data) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern("#######0");
        return StringUtils.leftPad(nf.format(data), 8, ' ');
    };
    public @Getter @Builder.Default String WS_EIBRESP = WS_EIBRESP_format
            .apply(0);
    public @Getter @Builder.Default String unnamedVariable9 = StringUtils
            .repeat(' ', 57);
    public @Getter @Builder.Default String unnamedVariable10 = "   EIBRESP2 = ";
    private final static Function<Integer, String> WS_EIBRESP2_format = (data) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern("#######0");
        return StringUtils.leftPad(nf.format(data), 8, ' ');
    };
    public @Getter @Builder.Default String WS_EIBRESP2 = WS_EIBRESP2_format
            .apply(0);
    public @Getter @Builder.Default String unnamedVariable11 = StringUtils
            .repeat(' ', 57);
    public @Getter @Builder.Default String unnamedVariable12 = StringUtils
            .repeat("*", 79);

    public void setunnamedVariable1(String source) {
        unnamedVariable1 = StringUtils.truncate(
                StringUtils.rightPad(source, 35), 35);
    }

    public void setunnamedVariable2(String source) {
        unnamedVariable2 = StringUtils.truncate(
                StringUtils.rightPad(source, 35), 35);
    }

    public void setunnamedVariable3(String source) {
        unnamedVariable3 = StringUtils.truncate(
                StringUtils.rightPad(source, 9), 9);
    }

    public void setunnamedVariable4(String source) {
        unnamedVariable4 = StringUtils.truncate(
                StringUtils.rightPad(source, 14), 14);
    }

    public void setWS_EIBTRNID(String source) {
        WS_EIBTRNID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setunnamedVariable5(String source) {
        unnamedVariable5 = StringUtils.truncate(
                StringUtils.rightPad(source, 61), 61);
    }

    public void setunnamedVariable6(String source) {
        unnamedVariable6 = StringUtils.truncate(
                StringUtils.rightPad(source, 14), 14);
    }

    public void setWS_EIBRSRCE(String source) {
        WS_EIBRSRCE = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setunnamedVariable7(String source) {
        unnamedVariable7 = StringUtils.truncate(
                StringUtils.rightPad(source, 57), 57);
    }

    public void setunnamedVariable8(String source) {
        unnamedVariable8 = StringUtils.truncate(
                StringUtils.rightPad(source, 14), 14);
    }

    public void setWS_EIBRESP(int source) {
        WS_EIBRESP = WS_EIBRESP_format.apply(source);
    }

    public void setunnamedVariable9(String source) {
        unnamedVariable9 = StringUtils.truncate(
                StringUtils.rightPad(source, 57), 57);
    }

    public void setunnamedVariable10(String source) {
        unnamedVariable10 = StringUtils.truncate(
                StringUtils.rightPad(source, 14), 14);
    }

    public void setWS_EIBRESP2(int source) {
        WS_EIBRESP2 = WS_EIBRESP2_format.apply(source);
    }

    public void setunnamedVariable11(String source) {
        unnamedVariable11 = StringUtils.truncate(
                StringUtils.rightPad(source, 57), 57);
    }

    public void setunnamedVariable12(String source) {
        unnamedVariable12 = StringUtils.truncate(
                StringUtils.rightPad(source, 79), 79);
    }

    public String getWS_ERROR_LINE1() {
        return unnamedVariable4 + WS_EIBTRNID + unnamedVariable5;
    }

    public String getWS_ERROR_LINE2() {
        return unnamedVariable6 + WS_EIBRSRCE + unnamedVariable7;
    }

    public String getWS_ERROR_LINE3() {
        return unnamedVariable8 + WS_EIBRESP + unnamedVariable9;
    }

    public String getWS_ERROR_LINE4() {
        return unnamedVariable10 + WS_EIBRESP2 + unnamedVariable11;
    }

    public void set(String source) {
        unnamedVariable1 = source.substring(0, 35);
        unnamedVariable2 = source.substring(35, 70);
        unnamedVariable3 = source.substring(70, 79);
        unnamedVariable4 = source.substring(79, 93);
        WS_EIBTRNID = source.substring(93, 97);
        unnamedVariable5 = source.substring(97, 158);
        unnamedVariable6 = source.substring(158, 172);
        WS_EIBRSRCE = source.substring(172, 180);
        unnamedVariable7 = source.substring(180, 237);
        unnamedVariable8 = source.substring(237, 251);
        WS_EIBRESP = source.substring(251, 259);
        unnamedVariable9 = source.substring(259, 316);
        unnamedVariable10 = source.substring(316, 330);
        WS_EIBRESP2 = source.substring(330, 338);
        unnamedVariable11 = source.substring(338, 395);
        unnamedVariable12 = source.substring(395, 474);
    }

    @Override
    public String toString() {
        return unnamedVariable1 + unnamedVariable2 + unnamedVariable3
                + unnamedVariable4 + getWS_EIBTRNID() + unnamedVariable5
                + unnamedVariable6 + getWS_EIBRSRCE() + unnamedVariable7
                + unnamedVariable8 + getWS_EIBRESP() + unnamedVariable9
                + unnamedVariable10 + getWS_EIBRESP2() + unnamedVariable11
                + unnamedVariable12;
    }
}
